﻿using Infragistics.Windows.Automation.Peers.DataPresenter;
using Infragistics.Windows.DataPresenter;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Automation.Peers;
using System.Windows.Automation.Provider;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace PeerTest
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            DataContext = this;
        }

        private CollectionViewSource _carViewSource;
        public CollectionViewSource CarViewSource
        {
            get
            {
                if (_carViewSource == null)
                {
                    _carViewSource = new CollectionViewSource();
                    _carViewSource.GroupDescriptions.Clear();
                    PropertyGroupDescription pgd = new PropertyGroupDescription("Make");

                    _carViewSource.GroupDescriptions.Add(pgd);

                }

                _carViewSource.Source = new List<Car>() { new Car() { Make = "Toyota", Model = "Corrolla", Year = 1999},
                    new Car() { Make = "Toyota", Model = "Prius", Year = 2004},
                    new Car() { Make = "Toyota", Model = "Camry", Year = 2009},
                    new Car() { Make = "Subaru", Model = "Outback", Year = 2006},
                    new Car() { Make = "Subaru", Model = "Forrester", Year = 2013},
                    new Car() { Make = "Chevy", Model = "Impala", Year = 2004},
                    new Car() { Make = "Chevy", Model = "Corvette", Year = 2006},
                
                };
                _carViewSource.View.Refresh();
                return _carViewSource;
            }
        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            AutomationPeer peer = DataPresenterBaseAutomationPeer.CreatePeerForElement(this.MyDataGrid); // Peer for XamDataGrid;
            AutomationPeer recordsPeer = peer.GetChildren()[0]; // RecordCollectionAutomationPeer;
            AutomationPeer groupBandPeer = recordsPeer.GetChildren()[1]; // 2nd grouprecordpresenter;

            // invalid operation exception occurs on next line
            IExpandCollapseProvider expandPattern = groupBandPeer.GetPattern(PatternInterface.ExpandCollapse) as IExpandCollapseProvider;
            expandPattern.Expand();
        }



      
    }
}
